/**
* Script: enemy.js
* Written by: Radnen
* Updated: 12/16/2013
**/

var red = CreateColor(255, 0, 0);
var black = CreateColor(0, 0, 0);

function Enemy(name)
{
	this.name = name;
	this.maxhp = 25;
	this.hp = 25;
	this.timer = new Tween(25);
	this.time = GetTime();
	this.dead = false;
	this.x = 0;
	this.y = 0;
}

Enemy.prototype.update = function() {
	this.x = GetPersonX(this.name);
	this.y = GetPersonY(this.name);
	
	if (this.time + 1000 < GetTime()) {
		if (GetDistance("player", this.name) < 32) { engine.swing(this.name); }
		this.time = GetTime();
	}
}

Enemy.prototype.render = function() {
	Rectangle(MapToScreenX(0, this.x-8), MapToScreenY(0, this.y-16), this.timer.value / this.maxhp * 16, 2, red);
	OutlinedRectangle(MapToScreenX(0, this.x-9), MapToScreenY(0, this.y-17), 17, 3, black);
}

Enemy.prototype.hurt = function(value) {
	this.timer.setup(this.hp, this.hp - value, 200);
	this.hp -= value;
	SetTile(GetTileX(this.name), GetTileY(this.name), 1, 16);
	if (this.hp <= 0 && !this.dead) {
		this.dead = true;
		engine.player.kills++;
		var item = Math.floor(Math.random()*(g_counts.length + 2)) - 1;
		if (item >= 0)
			engine.addItem(item, GetTileX(this.name), GetTileY(this.name));
	}
}
