/**
* Script: stuff.js
* Written by: Radnen
* Updated: 12/16/2013
**/

RequireScript("json2.js");

function ShowTitle()
{
	var items = ["Play", "Hiscores", "Quit"];
	var credits = "Made for LD 28, by Radnen (code, sounds, art), MetalGrunt (art, gamedesign), and DaVince (music). Thank you all!!!";
	var ops = [NewGame, ShowHighscores, Exit];
	var sel = 0;
	var done = false;
	var time = GetTime();
	var drop = new Tween();
	var count = 0;
	var ctime = GetTime();
	drop.setup(-120, 0, 500);
	
	function select() {
		done = true;
	}
	
	while (!done) {
		drop.update();
		Resources.images.titlebg.blit(0, 0);
		Resources.images.title.blit(0, drop.value);
		
		if (!drop.isFinished()) { FlipScreen(); continue; }
		
		var y = SH/2-52;
		
		List.foreach(items, function(item, i) {
			var w = Resources.fonts.font.getStringWidth(item)/2;
			Resources.fonts.font.drawText(SW/2 - w, y + i*16, item);
		});
		
		var w2 = Resources.fonts.font.getStringWidth(items[sel])/2;
		Resources.images.arrow.blit(SW/2-16-w2, y + sel*16);
		
		if (ctime + 10 < GetTime()) {
			count++;
			ctime = GetTime();
			if (count == 6*SW) count = 0;
		}
		Resources.fonts.font.drawText(SW-count, SH-20, credits);
		
		FlipScreen();
		
		if (time + 100 < GetTime()) {
			if (Input.axisUp && sel > 0) sel--;
			if (Input.axisDown && sel < 2) sel++;
			time = GetTime();
		}
		
		Input.onButtonDown(Input.StartButton, select);
		Input.onButtonDown(Input.AButton, select);
		
		while (AreKeysLeft()) {
			switch(GetKey()) {
				case KEY_UP: if (sel > 0) sel--; break;
				case KEY_DOWN: if (sel < 2) sel++; break;
				case KEY_SPACE:
				case KEY_CTRL:
				case KEY_ENTER: select(); break;
			}
		}
	}
	
	ops[sel]();
}

function ShowCharacterSelect() {
	var items = ["lass", "villager", "monk", "wizard", "guard", "king"];
	var sel = 0;
	var done = false;
	var time = GetTime();
	var ss = [];
	ss[0] = LoadSpriteset("player1.rss").images[0];
	ss[1] = LoadSpriteset("player2.rss").images[0];
	ss[2] = LoadSpriteset("player3.rss").images[0];
	ss[3] = LoadSpriteset("player4.rss").images[0];
	ss[4] = LoadSpriteset("player5.rss").images[0];
	ss[5] = LoadSpriteset("player6.rss").images[0];
	
	function select() {
		done = true;
	}
	
	while (!done) {
		Resources.images.titlebg.blit(0, 0);
		Resources.images.title.blit(0, 0);
		
		var x = SW/2-80;
		var y = SH/2-32;

		Resources.fonts.font.drawText(x, y-16, "Choose character:");
		Resources.images.arrow2.blit(x, y+8);
		ss[sel].blit(x+16, y+8);
		Resources.fonts.font.drawText(x+40, y+8, items[sel]);
		Resources.images.arrow.blit(x+136, y+8);
		
		FlipScreen();
		
		if (time + 100 < GetTime()) {
			if (Input.axisLeft && sel > 0) sel--;
			if (Input.axisRight && sel < 2) sel++;
			time = GetTime();
		}
		
		Input.onButtonDown(Input.StartButton, select);
		Input.onButtonDown(Input.AButton, select);
		
		while (AreKeysLeft()) {
			switch(GetKey()) {
				case KEY_LEFT: if (sel > 0) sel--; break;
				case KEY_RIGHT: if (sel < 5) sel++; break;
				case KEY_SPACE:
				case KEY_CTRL:
				case KEY_ENTER: select(); break;
			}
		}
	}
	
	g_ss = "player"+(sel+1)+".rss";
}

function ShowName() {
	var done = false;
	var name = "";
	
	function select() {
		done = true;
	}
	
	while (!done) {
		Resources.images.titlebg.blit(0, 0);
		Resources.images.title.blit(0, 0);
		
		var x = SW/2-80;
		var y = SH/2-32;

		Resources.fonts.font.drawText(x, y, "Name: " + name);
		var w = Resources.fonts.font.getStringWidth("Name: " + name);
		
		var date = new Date();
		if (date.getMilliseconds() < 500) {
			Resources.fonts.font.drawText(x+w, y, "|");
		}
		
		FlipScreen();
		
		Input.onButtonDown(Input.StartButton, select);
		Input.onButtonDown(Input.AButton, select);
		
		while (AreKeysLeft()) {
			var k = GetKey();
			switch (k) {
				case KEY_SPACE:
				case KEY_CTRL:
				case KEY_ENTER: select(); break;
				case KEY_BACKSPACE: name = name.substring(0, name.length-1); break;
				default: name += GetKeyString(k, IsKeyPressed(KEY_SHIFT)); break;
			}
		}
	}
	
	g_name = name;
}

function ShowWin() {
	g_score = engine.player.kills*1000 + engine.player.hp*100;
	var done = false;
	
	function select() {
		done = true;
	}
	
	while (!done) {
		Resources.images.titlebg.blit(0, 0);
		Resources.images.title.blit(0, 0);
		
		var x = SW/2-88;
		var y = SH/2-56;

		Resources.fonts.font.drawText(x, y, "You survived!");
		Resources.fonts.font.drawText(x, y+16, g_name + "'s score: ");
		Resources.fonts.font.drawText(x, y+32, g_score);
		
		FlipScreen();
		
		Input.onButtonDown(Input.StartButton, select);
		Input.onButtonDown(Input.AButton, select);
		
		while (AreKeysLeft()) {
			var k = GetKey();
			switch (k) {
				case KEY_SPACE:
				case KEY_CTRL:
				case KEY_ENTER: select(); break;
			}
		}
	}

	AddScore();
	ExitMapEngine();
	g_name = "";
}


function ShowDeath() {
	g_score = engine.player.kills*1000 + engine.player.hp*100;
	var done = false;
	
	function select() {
		done = true;
	}
	
	while (!done) {
		Resources.images.titlebg.blit(0, 0);
		Resources.images.title.blit(0, 0);
		
		var x = SW/2-88;
		var y = SH/2-56;

		Resources.fonts.font.drawText(x, y, "You like... died.");
		Resources.fonts.font.drawText(x, y+16, g_name + "'s score: ");
		Resources.fonts.font.drawText(x, y+32, g_score);
		
		FlipScreen();
		
		Input.onButtonDown(Input.StartButton, select);
		Input.onButtonDown(Input.AButton, select);
		
		while (AreKeysLeft()) {
			var k = GetKey();
			switch (k) {
				case KEY_SPACE:
				case KEY_CTRL:
				case KEY_ENTER: select(); break;
			}
		}
	}

	AddScore();
	ExitMapEngine();
	g_name = "";
}

function ShowHighscores() {
	var done = false;
	LoadHighscores();
	var ss = [];
	ss["player1.rss"] = LoadSpriteset("player1.rss").images[0];
	ss["player2.rss"] = LoadSpriteset("player2.rss").images[0];
	ss["player3.rss"] = LoadSpriteset("player3.rss").images[0];
	ss["player4.rss"] = LoadSpriteset("player4.rss").images[0];
	ss["player5.rss"] = LoadSpriteset("player5.rss").images[0];
	ss["player6.rss"] = LoadSpriteset("player6.rss").images[0];
	var timers = [];

	for (var i = 0; i < 10; ++i) {
		timers[i] = new Tween();
		timers[i].setup(0, 32, 100+i*100);
	}
	
	function select() { done = true; }
	
	while (!done) {
		Resources.images.titlebg.blit(0, 0);
		
		var x = 16;
		var y = 16;

		Resources.fonts.font.drawText(x, y-16, "Highscores: ");
		List.foreach(g_scores, function(item, i) {
			timers[i].update();
			Resources.fonts.font.drawText(timers[i].value+16, y+20+i*16, (i+1) + ". " + item.name + ": " + item.score);
			ss[item.ss].blit(timers[i].value, y+20+i*16);
		});
		
		Resources.fonts.font.drawText(0, SH-20, "ENTER or Start to go back.");
		
		FlipScreen();
		
		Input.onButtonDown(Input.StartButton, select);
		Input.onButtonDown(Input.AButton, select);
		
		while (AreKeysLeft()) {
			var k = GetKey();
			switch (k) {
				case KEY_SPACE:
				case KEY_CTRL:
				case KEY_ENTER: select(); break;
				case KEY_BACKSPACE: k.substr(0, k.length-1); break;
				default: name += GetKeyString(k, IsKeyPressed(KEY_SHIFT)); break;
			}
		}
	}
	
	ShowTitle();
}

var g_scores = [];

function LoadHighscores() {
	var file = OpenFile("scores.sav");
	var data = file.read("scores", "[]");
	g_scores = JSON.parse(data);
	file.close();
}

function CreateBlankHS()
{
	var s1 = {name: "King", score: 20000, ss: "player6.rss"};
	var s2 = {name: "Guard", score: 18000, ss: "player5.rss"};
	var s3 = {name: "Wizard", score: 16000, ss: "player4.rss"};
	var s4 = {name: "Monk", score: 14000, ss: "player3.rss"};
	var s5 = {name: "Villager", score: 12000, ss: "player2.rss"};
	var s6 = {name: "Lass", score: 10000, ss: "player1.rss"};
	var scores = [s1, s2, s3, s4, s5, s6];
	
	var file = OpenFile("scores.sav");
	file.write("scores", JSON.stringify(scores));
	file.flush();
	file.close();
}

// CreateBlankHS();

function SaveHighscore()
{
	var file = OpenFile("scores.sav");
	file.write("scores", JSON.stringify(g_scores));
	file.flush();
	file.close();
}

function AddScore()
{
	LoadHighscores();
	g_scores.push({ score: g_score, name: g_name, ss: g_ss });
	g_scores.sort(function(a, b) { return b.score - a.score; });
	if (g_scores.length > 9) g_scores.pop();
	SaveHighscore();
}

function NewGame()
{
	engine.reset();
	
	ShowCharacterSelect();
	ShowName();
	
	CreatePerson("player", g_ss, true);
	amble.attachInput("player");
	AttachCamera("player");
	SetUpdateScript("update();");
	SetRenderScript("render();");
	MapEngine("maindungeon2.rmp", 60);
}