/**
* Script: traps.js
* Written by: Radnen
* Updated: 12/15/2013
**/

function Trap(name) {
	this.ai = null;
	this.name = name;
	this.dead = false;
	this.state = false;
	this.ss = "spikes.rss";
	this.layer = 0;
}

function BombTrap(name) {
	Trap.call(this, name);
	this.ss = "bomb.rss";
	this.time = GetTime();
	this.layer = 0;
	
	this.hurt = function(o) {
		o.hurt(25);
	}
	
	this.ai = function() {
		frame = GetPersonFrame(this.name);
		
		if (frame < 8 && this.time + 500 < GetTime()) {
			SetPersonFrame(this.name, frame + 1);
			this.time = GetTime();
			if (frame + 1 > 3) this.time -= 450;
			if (frame + 1 == 4) Audio.playSound(Resources.sounds.explosion);
		}
		
		if (frame != 8) return;
		this.dead = true;
		
		if (GetDistance(this.name, "player") <= 32) this.hurt(engine.player);
		
		List.foreach(engine.getEnemies(), function(enemy) {
			if (GetDistance(this.name, enemy.name) <= 32) this.hurt(enemy);
		}, this);
		
		List.foreach(engine.getTraps(), function(trap) {
			if (GetDistance(this.name, trap.name) <= 32) trap.dead = true;
		}, this);
	}
}

function SpikeTrap(name) {
	Trap.call(this, name);
	this.time = GetTime();
	this.state = 2;
	this.times = 5;
	
	this.hurt = function(o) {
		o.hurt(5);
		this.state = 1;
		this.time = GetTime();
		SetPersonFrame(this.name, 1);
		Audio.playSound(Resources.sounds.spike);
		this.times--;
		if (this.times == 0) this.dead = true;
	}
	
	this.ai = function() {
		switch (this.state) {
			case 0:
				List.foreach(GetPersonList(), function(name) {
					if (GetDistance(this.name, name) < 16) {
						if (name == "player") { this.hurt(engine.player); }
						else {
							var e = engine.getEnemy(name);
							if (e) { this.hurt(e); }
						}
					}
				}, this);
			break;
			case 1:
				if (this.time + 500 < GetTime()) { SetPersonFrame(this.name, 0); this.state = 0; }
			break;
			case 2:
				if (this.time + 1000 < GetTime()) { this.state = 0; }
			break;
		}
	}
}

function WallSpike(name) {
	Trap.call(this, name);
	
	this.ai = function() {
		
	}
}